# Configuration file for DesktopDig
import os
import re
import string
import sys

import ConfigParser

# Add the path to your egenix installation if it's not installed system-wide:
sys.path.append("/space/home/docs/egenix/lib/python2.2/site-packages/")

BASEDIR = re.sub("^(.*)/.*?$", "\\1", os.path.abspath(sys.argv[0]))
sys.path.append(os.path.join(BASEDIR, "backend"))

VERSION = "0.1"

class Config:

	def __init__(self):
		self.configfile = os.path.join(BASEDIR, "desktopdig.config")
		self.config = ConfigParser.ConfigParser()
		self.config.read(self.configfile)
		return

	def save(self, dict, section="General"):
		file = open(self.configfile, "w")
		if not self.config.has_section("General"):
			self.config.add_section("General")
		for key in dict.keys():
			# FIXME: escape "," in names!
			self.config.set(section, key, str(dict[key]))
		self.config.write(file)
		file.close()
		return
		
	def getInt(self, name, section="General"):
		try:
			val = self.config.get(section, name)
		except ConfigParser.NoSectionError:
			# fixme: what to do?
			print "No config yet"
		return int(val)

	def getString(self, name, section="General"):
		try:
			val = self.config.get(section, name)
		except ConfigParser.NoSectionError:
			# fixme: what to do?
			print "No config yet"
		return val

	def getList(self, name, section="General"):
		try:
			l = string.split(self.config.get(section, name), ",")
			new_l = []
			for item in l:
				if item == 'None':
					# needed to express "index files with no suffix"
					new_l.append(None)
				else:
					new_l.append(item)
		except ConfigParser.NoSectionError:
			# fixme: what to do?
			print "No config yet"
			return []
		return new_l
