# This file is part of DesktopDig
# Copyright (C) 2002 Daniel Naber <daniel.naber@t-online.de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

class IndexedDocument:
	
	def __init__(self, doc_id, url, title, author, description, 
			size, date, term_count, content=None):
		self.doc_id = doc_id
		self.url = url
		self.title = title
		self.author = author
		self.description = description	# to show a short summary (if there's no self.content)
		self.size = size
		self.date = date
		self.term_count = term_count	# number of words in this document (all words, not just unique words)
		self.content = content		# to show result in context
		# This could be used to speed up updating the index, but
		# we use an extra table (self.words_table) in FullTextIndex
		# for that, because it's only needed for changing the index,
		# not for searching:
		# self.terms = terms
		return
