# A very simple set class.
# This file is part of DesktopDig
# Copyright (C) 2002 Daniel Naber <daniel.naber@t-online.de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

class Set:

	def __init__(self):
		# emulate a set using a hash table to avoid duplicates,
		# saving the elements as keys
		self.table = {}
		return
		
	def add(self, elem):
		self.table[elem] = 1
		return

	def addList(self, lst):
		for elem in lst:
			self.add(elem)
		return

	def remove(self, elem):
		try:
			del self.table[elem]
		except KeyError:
			pass
		return
		
	def removeSet(self, set2):
		for elem in set2.table.keys():
			try:
				del self.table[elem]
			except KeyError:
				pass
		return self

	def hasElement(self, elem):
		if self.table.has_key(elem):
			return 1
		else:
			return 0

	def union(self, set2):
		self.addList(set2.asList())
		return self
		
	def intersection(self, set2):
		new_set = Set()
		for elem in self.table.keys():
			try:
				if set2.table[elem]:
					new_set.add(elem)
			except KeyError:
				pass
		self.table = new_set.table
		return self

	def asList(self):
		"Get elements in alphabetical order."
		lst = []
		for elem in self.table.keys():
			lst.append(elem)
		lst.sort()
		return lst

	# TODO: set operations?
