#!/usr/bin/python
# This file is part of DesktopDig
# Copyright (C) 2002 Daniel Naber <daniel.naber@t-online.de>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

import Tokenizer

import unittest

class TokenizerTest(unittest.TestCase):

	def testTokenizer(self):
		tokenizer = Tokenizer.Tokenizer()
		#print tokenizer.tokenize('      foo-bar  ')
		#assert(tokenizer.tokenize(None) == [])
		self.assertEqual(tokenizer.tokenize(''), [])
		self.assertEqual(tokenizer.tokenize('foo'), ['foo'])
		self.assertEqual(tokenizer.tokenize('foo bar'), ['foo', 'bar'])
		self.assertEqual(tokenizer.tokenize('foo <!-- urg\nbla --> <i>bar</i>'), ['foo', 'bar'])
		self.assertEqual(tokenizer.tokenize('foo <!-- urg\nbla --> <i>b<em>a</em>r</i>'), ['foo', 'bar'])
		self.assertEqual(tokenizer.tokenize('      foo  \t    bar  '), ['foo', 'bar'])
		# todo: is this correct?:
		self.assertEqual(tokenizer.tokenize('      foo-bar  '), ['foo-bar'])
		self.assertEqual(tokenizer.tokenize('##TT, Bus!!'), ['tt', 'bus'])
		self.assertEqual(tokenizer.tokenize('##, Bus!!'), ['', 'bus'])
	
if __name__ == "__main__":
    unittest.main()
